
/* 
 2013/07 : Modified after_vectors* to after_vectors
 2012/11 : Modified for LPC1114FN28 
 Linker script for LPC238x       v0.2
 2011/05 v0.2: Modified Align(8) to Align(4).
 2011/05 v0.1: Modified for LPC176x.
          Added code read protection ( C.R.P.) region.

  http://avr.paslog.jp
  Copyright (c) 2011-2013 audin.
  This file is licensed under the MIT License.

*/


/* Linker script for Altera Cyclone III Cortex-M1
 *
 * Version: Sourcery G++ Lite 2011.03-42
 * Support: https://support.codesourcery.com/GNUToolchain/
 *
 * Copyright (c) 2007, 2008, 2009, 2010 CodeSourcery, Inc.
 *
 * The authors hereby grant permission to use, copy, modify, distribute,
 * and license this software and its documentation for any purpose, provided
 * that existing copyright notices are retained in all copies and that this
 * notice is included verbatim in any distributions. No written agreement,
 * license, or royalty fee is required for any of the authorized uses.
 * Modifications to this software may be copyrighted by their authors
 * and need not follow the licensing terms described here, provided that
 * the new terms are clearly indicated on the first page of each file where
 * they apply.
 */
OUTPUT_FORMAT("elf32-littlearm", "elf32-littlearm", "elf32-littlearm")
OUTPUT_ARCH(arm)


SEARCH_DIR(.)
/* for Redlib with CodeRed syscalls*/
/*GROUP(libcr_c.a libcr_nohost.a libm.a libcr_eabihelpers.a)*/

/* for Redlib with CodeRed semihost*/
/*GROUP(libcr_c.a libcr_semihost.a libm.a libcr_eabihelpers.a)*/

/* for Newlib with CodeRed syscalls */
/*GROUP(libgcc.a libc.a libm.a libcr_newlib_nohost.a)*/

/* for Newlib gnu */
GROUP(libgcc.a libc.a libm.a )


MEMORY
{
  flash(rx): ORIGIN = 0x00000000, LENGTH = 32K
  sram(rwx): ORIGIN = 0x10000000+0, LENGTH = 4K-0
}

  sram_top		= ORIGIN(sram) + LENGTH(sram);
  _vStackTop	= sram_top - 16;
  stack_entry	= _vStackTop;
__stack_end__	= _vStackTop;

ENTRY(boot_entry)

SECTIONS
{  
  .text : ALIGN(4)
    {
		FILL(0xff)
        /* KEEP(*(.startup)) */
		KEEP(*(.irq_vectors))
		KEEP(*(.irq_funcs))
	    KEEP(*(.isr_vector .isr_vector.*))
        KEEP(*(.boot_vector))
        /* KEEP(*(.VECTOR)) */
	/***    ***/
		*(.after_vectors)
		*(.after_vectors2)
	 /*** For code read protection. C.R.P. ***/
		. = 0x2fc;
		KEEP(*(.CRP._0x02FC))
	 /***								   ***/
	. = ALIGN(4) ;

    *(.text .text.* .gnu.linkonce.t.*)
    *(.plt)
    *(.gnu.warning)
    *(.glue_7t) *(.glue_7) *(.vfp11_veneer)
	. = ALIGN(4) ;
        *(.ARM.extab* .gnu.linkonce.armextab.*)
        *(.gcc_except_table)
    } >flash

  .eh_frame_hdr : ALIGN (4)
  {
    KEEP (*(.eh_frame_hdr))
  } >flash
  .eh_frame : ALIGN (4)
  {
    KEEP (*(.eh_frame))
  } >flash

  /* .ARM.exidx is sorted, so has to go in its own output section.  */
  PROVIDE_HIDDEN (__exidx_start = .);
  .ARM.exidx : ALIGN(4)
	{ 
		*(.ARM.exidx* .gnu.linkonce.armexidx.*) 
	} >flash
  PROVIDE_HIDDEN (__exidx_end = .);

  .rodata : ALIGN (4)
  {
    *(.rodata .rodata.* .gnu.linkonce.r.*)

	. = ALIGN(4);
	KEEP(*(.init))

	. = ALIGN(4);
	__preinit_array_start = .;
	KEEP (*(.preinit_array))
	__preinit_array_end = .;

	. = ALIGN(4);
	__init_array_start = .;
	KEEP (*(SORT(.init_array.*)))
	KEEP (*(.init_array))
	__init_array_end = .;

	. = ALIGN(4);
	KEEP(*(.fini))

	. = ALIGN(4);
	__fini_array_start = .;
	KEEP (*(.fini_array))
	KEEP (*(SORT(.fini_array.*)))
	__fini_array_end = .;

    . = ALIGN(4);
    KEEP (*crtbegin.o(.ctors))
    KEEP (*(EXCLUDE_FILE (*crtend.o) .ctors))
    KEEP (*(SORT(.ctors.*)))
    KEEP (*crtend.o(.ctors))

        . = ALIGN(4);
	KEEP (*crtbegin.o(.dtors))
	KEEP (*(EXCLUDE_FILE (*crtend.o) .dtors))
	KEEP (*(SORT(.dtors.*)))
	KEEP (*crtend.o(.dtors))

	. = ALIGN(4);
    *(.rom)
    *(.rom.b .bss.rom)
  } >flash

.text.align :
  {
	 /* End Of .text section */
    . = ALIGN(4);
    __end_of_text__ = .;
    _etext = .;
  } >flash

  .data : AT(_etext)
    {
	    _sdata = .;
		__data_beg__ = .;
		__data_beg_src__ = __end_of_text__;
		_data        = .;
	KEEP(*(.jcr))
	*(.got.plt) *(.got)
	*(.shdata)
	*(.data .data.* .gnu.linkonce.d.*)
        . = ALIGN(4);
	*(.ram)
	. = ALIGN(4);
	_edata = .;
	__data_end__ = .;
  } >sram

  .bss : ALIGN(4)
    {
		__bss_beg__   = .;
		__bss_start__ = .;
	_sbss = . ;
	_bss  = . ;
	*(.shbss)
	*(.bss .bss.* .gnu.linkonce.b.*)
	*(COMMON)
    . = ALIGN(4);
    *(.ram.b .bss.ram)
	. = ALIGN(4);
	_end  = .;
	__end = .;
	PROVIDE(end = .);
	_ebss = . ;
	_pvHeapStart = .;
	__bss_end__ = .;
    end = .;
   _end = . ;
  } >sram

/*
	* This used for USB RAM section *
  .usb_ram (NOLOAD):
  {
	 *.o (USB_RAM)
  } > uram
*/



  .stab 0 (NOLOAD) : { *(.stab) }
  .stabstr 0 (NOLOAD) : { *(.stabstr) }
  /* DWARF debug sections.
   * Symbols in the DWARF debugging sections are relative to
   * the beginning of the section so we begin them at 0.
   */
  /* DWARF 1 */
  .debug		  0 : { *(.debug) }
  .line		   0 : { *(.line) }
  /* GNU DWARF 1 extensions */
  .debug_srcinfo  0 : { *(.debug_srcinfo) }
  .debug_sfnames  0 : { *(.debug_sfnames) }
  /* DWARF 1.1 and DWARF 2 */
  .debug_aranges  0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  /* DWARF 2 */
  .debug_info	 0 : { *(.debug_info .gnu.linkonce.wi.*) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line	 0 : { *(.debug_line) }
  .debug_frame	0 : { *(.debug_frame) }
  .debug_str	  0 : { *(.debug_str) }
  .debug_loc	  0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }
  /* DWARF 2.1 */
  .debug_ranges   0 : { *(.debug_ranges) }
  /* SGI/MIPS DWARF 2 extensions */
  .debug_weaknames 0 : { *(.debug_weaknames) }
  .debug_funcnames 0 : { *(.debug_funcnames) }
  .debug_typenames 0 : { *(.debug_typenames) }
  .debug_varnames  0 : { *(.debug_varnames) }

  .note.gnu.arm.ident 0 : { KEEP (*(.note.gnu.arm.ident)) }
  .ARM.attributes 0 : { KEEP (*(.ARM.attributes)) }
  /DISCARD/ : { *(.note.GNU-stack) }
}


/*
#########################################################################
# References:
# NXP CMSIS/etc page 
# http://ics.nxp.com/support/documents/microcontrollers/?sort=date#All

# Direct link for CMSIS Drivers lpc17xx
# http://ics.nxp.com/support/documents/microcontrollers/zip/lpc17xx.cmsis.driver.library.zip


#########################################################################

# The MIT License
# 
# Copyright (c) 2011-2012 audin.
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
# 
*/
