/*
# Copyright (C) 2013 audin.
# 2013/07: Modified for LPC1114FN28.
# 2012/11
# http://avr.paslog.jp
# This file is licensed under the MIT License.
*/

#include "sys.h"
#include "after_vectors.h"

static volatile uint32_t ticks = 0;

/*******************

* SysTick_Handler
  
 *******************/
__AFTER_VECT2
void SysTick_Handler(void)		/* 1msec Timer ISR */
{
	ticks++;
}

/*******************

* systick_init
  
 *******************/
__AFTER_VECT2
void systick_init( void ){
	/* Enable SysTick timer in interval of 1ms */
	SysTick_Config(SystemCoreClock / 1000);
}

/*******************

* millis
  
 *******************/
__AFTER_VECT2
uint32_t millis(void){
	return ticks;
}

/*******************

* delay_ms
  
 *******************/
void delay_ms( uint32_t ms){
	uint32_t prev;
	prev = ticks;
	while( ( ticks - prev ) < ms );
}

