/*
#
# Copyright (C) 2010-2013, audin
# 2013/07: Modify for LPCOpen Platform.
# 2011/04, 2012/11
# 2010/11
# http://avr.paslog.jp
# This file is licensed under the MIT License.
#
*/

#include "sys.h"
#include "sio_tsk.h"
#include "led_tsk.h"
#include "Scheduler.h"

static int max_val	= 0;
static int val		= 0;

/* for CQ MyARM ,lpc1114fn28 */
static const uint8_t LED1		= 0;
static const uint8_t LED2		= 1;
#define led1_on()		Board_LED_Set(LED1, true);
#define led1_off()		Board_LED_Set(LED1, false);
#define led2_on()		Board_LED_Set(LED2, true);
#define led2_off()		Board_LED_Set(LED2, false);

/*******************

* LED1　初期化
  
 *******************/
void led_init(void)
{
  	led1_off();									/*  最初はOFF	*/
}

/*******************

* Fake PWM
 
 *******************/
static void pwm( int ms )
{
	led1_on();
	wait( ms );
	led1_off();
	wait( max_val - val);
}

/*******************

* LED　点滅タスク
  
 *******************/
void led_task( void)
{
	led_tsk( (void *)0 );	/* Just stub */
}

void led_tsk( void *pvParameters )
{
	( void ) pvParameters;								// not used
	led_init();											// LEDポート初期化
	const int MIN_VAL	= 0;
	static int dir		= 1;
	while( 1 ){
		if( ( val >= max_val) || ( val <= MIN_VAL) ){
			max_val = sio_get_led_blink_speed() + 3 ;	// LED点滅周期の変更
			max_val <<= 1;								// 時間をテキトウに調整
			if( val <= MIN_VAL ){
				dir = 1;
				wait( 1000 );							// 明るさ０になったら、1秒待つ
			}
			else{ 
				dir = -1;
				val = max_val;
			}
		}
		val += dir;
		pwm( val );
	}
}

/*******************

* LED2　初期化

 *******************/
void led2_init(void)
{
  	led2_off();									/*  最初はOFF	*/
}

void led2_task( void ){
	led2_init();
	while( 1 ){
		led2_on();
		wait(2000);
		led2_off();
		wait(2000);
	}
}

